#
# spec file for package pdns (Version 2.9.20)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison boost boost-devel bzip2 coreutils cpio cpp cpp41 cracklib cvs cyrus-sasl cyrus-sasl-devel db diffutils docbook-dsssl-stylesheets docbook-toys docbook-utils docbook-xsl-stylesheets docbook_3 docbook_4 e2fsprogs file filesystem fillup findutils flex gawk gcc gcc-c++ gcc41 gcc41-c++ gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv iso_ent jadetex klogd krb5 latex-ucs less libacl libattr libcom_err libgcc41 libicu libltdl libmudflap41 libnscd libpng libstdc++41 libstdc++41-devel libtool libvolume_id libxcrypt libxml2 libzio linux-kernel-headers m4 make man mktemp module-init-tools mysql-client mysql-devel mysql-shared ncurses ncurses-devel net-tools netcfg openjade openldap2 openldap2-client openldap2-devel openslp opensp openssl openssl-devel pam pam-modules patch perl perl-SGMLS permissions popt postgresql-devel postgresql-libs procinfo procps psmisc pwdutils rcs readline rpm sed sgml-skel sqlite2 sqlite2-devel strace sysvinit tar tcpd te_latex tetex texinfo timezone unzip util-linux vim xorg-x11-libICE xorg-x11-libSM xorg-x11-libX11 xorg-x11-libXau xorg-x11-libXdmcp xorg-x11-libXext xorg-x11-libXmu xorg-x11-libXp xorg-x11-libXpm xorg-x11-libXt zlib zlib-devel


Name:           pdns
Version:        2.9.20
Release:        16
#
Group:          Productivity/Networking/DNS/Servers
License:        GPL v2 or later
#
%define home           %{_var}/lib/pdns
%define _localstatedir %{_var}/run/pdns
%define with_recursor  0
#
%if 0%{?opensuse_bs}
%define with_opendbx 1
%define with_xdb     1
%endif
#
BuildRequires:  boost-devel docbook-toys docbook-utils docbook-xsl-stylesheets gcc-c++ mysql-devel openldap2 openldap2-devel postgresql-devel sqlite2-devel
# we add opendbx-backend-sqlite2 as we pull in sqlite2 anyway and we need one installed backend
%if 0%{?with_opendbx}
BuildRequires:  opendbx-backend-sqlite2 opendbx-devel
%endif
%if 0%{?with_xdb}
BuildRequires:  tdb-devel
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
PreReq:         %insserv_prereq %fillup_prereq /usr/sbin/useradd /usr/sbin/groupadd
#
Url:            http://www.powerdns.com/
Source:         %{name}-%{version}.tar.bz2
Source1:        rcpdns
Patch:          pdns-2.9.19-CVE-2006-2069.patch
%if 0%{?with_opendbx}
Source2:        README.opendbx
Patch1:         http://www.linuxnetworks.de/pdnsodbx/download/opendbxbackend_2.9.20-3.diff
%endif
Patch2:         pdns-2.9.17_cve-2006-4251.patch
Patch4:         pdns-2.9.20_2006-02.patch
Patch5:         %{name}-%{version}-CVE-2008-3337.patch
#
Summary:        Modern, advanced and high performance authoritative-only nameserver

%description
The PowerDNS Nameserver is a modern, advanced and high performance
authoritative-only nameserver. It is written from scratch and conforms
to all relevant DNS standards documents. Furthermore, PowerDNS
interfaces with almost any database.



Authors:
--------
    http://www.powerdns.com

%debug_package
%if %with_recursor

%package -n pdns-recursor
License:        GPL v2 or later
Group:          Productivity/Networking/DNS/Servers
Requires:       %{name} = %{version}
Summary:        Modern, advanced and high performance recursing/non authoritative nameserver

%description -n pdns-recursor
PowerDNS Recursor is a non authoritative/recursing DNS server. Use this
package if you need a dns cache for your network.



Authors:
--------
    http://www.powerdns.com

%endif

%package backend-mysql
License:        GPL v2 or later
Group:          Productivity/Networking/DNS/Servers
Requires:       %{name} = %{version}
Summary:        MySQL backend for pdns

%description backend-mysql
The PowerDNS Nameserver is a modern, advanced and high performance
authoritative-only nameserver. It is written from scratch and conforms
to all relevant DNS standards documents. Furthermore, PowerDNS
interfaces with almost any database.

This package holds the MySQL backend for pdns.



Authors:
--------
    http://www.powerdns.com

%package backend-postgresql
License:        GPL v2 or later
Group:          Productivity/Networking/DNS/Servers
Requires:       %{name} = %{version}
Summary:        PostgreSQL backend for pdns

%description backend-postgresql
The PowerDNS Nameserver is a modern, advanced and high performance
authoritative-only nameserver. It is written from scratch and conforms
to all relevant DNS standards documents. Furthermore, PowerDNS
interfaces with almost any database.

This package holds the PostgreSQL backend for pdns.



Authors:
--------
    http://www.powerdns.com

%package backend-sqlite2
License:        GPL v2 or later
Group:          Productivity/Networking/DNS/Servers
Requires:       %{name} = %{version}
Summary:        SQLite 2 backend for pdns

%description backend-sqlite2
The PowerDNS Nameserver is a modern, advanced and high performance
authoritative-only nameserver. It is written from scratch and conforms
to all relevant DNS standards documents. Furthermore, PowerDNS
interfaces with almost any database.

This package holds the SQLite 2 backend for pdns.



Authors:
--------
    http://www.powerdns.com

%package backend-ldap
License:        GPL v2 or later
Group:          Productivity/Networking/DNS/Servers
Requires:       %{name} = %{version}
Summary:        LDAP backend for pdns

%description backend-ldap
The PowerDNS Nameserver is a modern, advanced and high performance
authoritative-only nameserver. It is written from scratch and conforms
to all relevant DNS standards documents. Furthermore, PowerDNS
interfaces with almost any database.

This package holds the LDAP backend for pdns.



Authors:
--------
    http://www.powerdns.com

%if 0%{?with_opendbx}

%package backend-opendbx
License:        GPL v2 or later
Group:          Productivity/Networking/DNS/Servers
Requires:       %{name} = %{version}
Summary:        OpenDBX backend for pdns

%description backend-opendbx
The PowerDNS Nameserver is a modern, advanced and high performance
authoritative-only nameserver. It is written from scratch and conforms
to all relevant DNS standards documents. Furthermore, PowerDNS
interfaces with almost any database.

This package holds the OpenDBX backend for pdns.



Authors:
--------
    http://www.powerdns.com

%endif
%if 0%{?with_xdb}

%package backend-xdb
License:        GPL v2 or later
Group:          Productivity/Networking/DNS/Servers
Requires:       %{name} = %{version}
Summary:        Samba TDB backend for pdns

%description backend-xdb
The PowerDNS Nameserver is a modern, advanced and high performance
authoritative-only nameserver. It is written from scratch and conforms
to all relevant DNS standards documents. Furthermore, PowerDNS
interfaces with almost any database.

This package holds the Samba TDB backend for pdns.



Authors:
--------
    http://www.powerdns.com

%endif

%prep
%setup
%patch
%if 0%{?with_opendbx}
%patch1 -p1
%{__cp} %{S:2} README.opendbx
%endif
%patch2
%patch4
%patch5

%build
export CFLAGS="%{optflags} -DLDAP_DEPRECATED"
export CXXFLAGS="$CFLAGS"
%configure \
  --disable-static \
  --sysconfdir=%{_sysconfdir}/%{name} \
  --libdir=%{_libdir}/%{name} \
  --with-sqlite-lib=%{_libdir} \
  --with-pgsql-lib=%{_libdir} \
  --with-mysql-lib=%{_libdir} \
  --with-modules="" \
  --with-dynmodules="gmysql gpgsql gsqlite ldap pdns pipe geo \
%if 0%{?with_opendbx}
  opendbx \
%endif
%if 0%{?with_xdb}
  xdb\
%endif
  " \
%if %with_recursor
  --enable-recursor
%else
  --disable-recursor # we have an external package for that.
%endif
%{__make}
pushd pdns/docs
  db2html -o html pdns.sgml
  find . -type d -exec chmod 755 {} \;
  find . -type f -exec chmod 644 {} \;
  %{__ln_s} book1.html html/index.html
popd

%install
%makeinstall
%{__install} -Dd -m 0755 %{buildroot}{%{home},%{_localstatedir}}
%{__mv} %{buildroot}%{_sysconfdir}/%{name}/pdns.conf{-dist,}
%{__install} -D -m 0755 %{S:1} %{buildroot}/etc/init.d/%{name}
%{__ln_s} -f ../../etc/init.d/%{name} %{buildroot}%{_sbindir}/rc%{name}
%{__rm} -rfv %{buildroot}%{_libdir}/pdns/*.la

%clean
%{__rm} -rf %{buildroot}

%pre
/usr/sbin/groupadd -r pdns &>/dev/null || :
/usr/sbin/useradd -o -g pdns -s /bin/false -r -c "pdns" -d %{home} pdns &>/dev/null || :

%post
%{fillup_and_insserv pdns}

%preun
%stop_on_removal pdns

%postun
%restart_on_update pdns
%insserv_cleanup

%files
%defattr (-,root,root,-)
%doc ChangeLog HACKING INSTALL README* TODO
%doc pdns/docs/html
/etc/init.d/%{name}
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%{_bindir}/pdns_control
%{_bindir}/zone2ldap
%{_bindir}/zone2sql
%{_sbindir}/rcpdns
%{_sbindir}/pdns_server
%{_mandir}/man8/pdns_control.8.gz
%{_mandir}/man8/pdns_server.8.gz
%{_mandir}/man8/zone2sql.8.gz
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/libpdnsbackend.so*
%{_libdir}/%{name}/libpipebackend.so*
%{_libdir}/%{name}/libgeobackend.so*
%dir %{home}
%dir %{_localstatedir}
%if %with_recursor

%files -n pdns-recursor
%defattr (-,root,root,-)
%{_sbindir}/pdns_recursor
%endif

%files backend-mysql
%defattr (-,root,root,-)
%{_libdir}/%{name}/libgmysqlbackend.so*

%files backend-postgresql
%defattr (-,root,root,-)
%{_libdir}/%{name}/libgpgsqlbackend.so*

%files backend-sqlite2
%defattr (-,root,root,-)
%{_libdir}/%{name}/libgsqlitebackend.so*

%files backend-ldap
%defattr (-,root,root,-)
%{_libdir}/%{name}/libldapbackend.so*
%if 0%{?with_opendbx}

%files backend-opendbx
%defattr (-,root,root,-)
%{_libdir}/%{name}/libopendbxbackend.so*
%endif
%if 0%{?with_xdb}

%files backend-xdb
%defattr (-,root,root,-)
%{_bindir}/xdb-fill
%{_libdir}/%{name}/libxdbbackend.so*
%endif

%changelog
* Mon Aug 11 2008 - anosek@suse.cz
- fixed VUL-0: pdns: URGENT: PowerDNS security update 2.9.21.1
  (bnc#415369) (CVE-2008-3337.patch)
* Mon Nov 13 2006 - mrueckert@suse.de
- added pdns-2.9.20_2006-02.patch:
  fix an endless recursion in CNAME handling [#219355]
* Sun Nov 12 2006 - mrueckert@suse.de
- added pdns-2.9.17_cve-2006-4251.patch:
  fix a stack corruption with malformed packages [#219355]
* Thu Oct 19 2006 - mrueckert@suse.de
- this is a sync to the buildservice package in server:dns:
- remove .la files
* Fri Oct 13 2006 - mrueckert@suse.de
- added opendbxbackend_2.9.20-3.diff:
  updates the opendbx backend to the latest version
* Fri May 19 2006 - mrueckert@suse.de
- disable the recursor as we use the newer external package.
* Thu May 04 2006 - nadvornik@suse.cz
- fixed crash on malformed packets CVE-2006-2069 [#170542]
* Sun Mar 26 2006 - mrueckert@suse.de
- fixed Requires for the subpackages
* Sat Mar 25 2006 - mrueckert@suse.de
- update to 2.9.20:
  Besides adding OpenDBX, this release is mostly about fixing
  problems and speeding up the recursor.
- disabled static support
- removed rm for the .a files
- splitted of the backends that pull in new dependencies
- removed patch. applied upstream.
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Nov 01 2005 - nadvornik@suse.cz
- updated to 2.9.19
* Tue Jun 07 2005 - nadvornik@suse.cz
- fixed init scripts
- used patches from http://www.linuxnetworks.de/pdnsldap/index.html
* Wed Apr 20 2005 - nadvornik@suse.cz
- fixed to compile on x86_64 with gcc4
* Fri Mar 11 2005 - nadvornik@suse.cz
- installed html documentation [#71738]
* Wed Feb 16 2005 - nadvornik@suse.cz
- new package
